<?php
header('Content-Type: application/json');

// Get method
$method = $_SERVER['REQUEST_METHOD'];

// Response
$response = [
    'status' => 'success',
    'message' => '',
    'data' => [],
];

if ($method === 'POST') {
    // header status for created
    http_response_code(201);

    $response['message'] = 'Data received';

    // Payload
    $raw = file_get_contents('php://input');
    $payload = json_decode($raw, true);
    if (json_last_error() === JSON_ERROR_NONE) {
        $site = $payload['site'] ?? '';
        switch ($site) {
            case 'tradingeconomics.com':
                $new_calendar = $payload['data'];

                // Storage file
                $filename = '/var/www/html/storage/tradingeconomics.json';

//                // Get cache file
//                $cache = file_get_contents($filename);
//                $calendar = json_decode($cache, true);
//                if (json_last_error() !== JSON_ERROR_NONE) {
//                    $calendar = [];
//                }
                $calendar = [];

                $now = time() * 1000 - (60 * 60 * 1000 * 7);
                foreach ($new_calendar as $event) {
                    // check ms and $now
                    if ($event['ms'] < $now) {
                        continue;
                    }
                    $calendar[$event['id']] = $event;
                    $calendar[$event['id']]['server_ms'] = $now;
                    $calendar[$event['id']]['second_left'] = round(($event['ms'] - $now) / 1000);
                }

                // Filter only US events
                $calendar = array_filter($calendar, function ($event) {
                    return $event['country'] === 'United States';
                });

                // Save cache
                file_put_contents($filename, json_encode($calendar));

                // Get file modify time
                $response['data']['file_ages'] = filemtime($filename);
                break;
            default:
                break;
        }
    } else {
        $response['status'] = 'error';
        $response['message'] = 'Invalid JSON payload';
    }
} else {
    $site = $_GET['site'] ?? '';
    switch ($site) {
        case 'tradingeconomics.com':
            $response['message'] = 'Calendar data';

            // Storage file
            $filename = '/var/www/html/storage/tradingeconomics.json';

            // Get cache file
            $cache = file_get_contents($filename);
            $calendar = json_decode($cache, true);
            if (json_last_error() !== JSON_ERROR_NONE) {
                $calendar = [];
            }

            // sort by value key ms
            usort($calendar, function ($a, $b) {
                return $a['ms'] <=> $b['ms'];
            });

            $response['data'] = array_values($calendar);
            break;
    }
}

echo json_encode($response);